/*
 * Made by Imara Speek, Paul Groenendaal and Aadjan van der Helm
 *
 * February 26 2015
 *
 */

// Defining the generic analog sensors
int sensor0 = A0;    // generic sensor 0
int sensor1 = A1;    // generic sensor 1
int sensor2 = A2;    // generic sensor 2
int sensor3 = A3;    // generic sensor 3

// values for the sensors
int sensorValue0 = 0;
int sensorValue1 = 0;
int sensorValue2 = 0;
int sensorValue3 = 0;

// Defining the generic Grove ports
int pin_D2 = 2;
int pin_D3 = 3;
int pin_D4 = 4;
int pin_D5 = 5;
int pin_D6 = 6;
int pin_D7 = 7;
int pin_D8 = 8;

// receiving values from the max patch
int actuatorD2 = 0;
int actuatorD3 = 0;
int actuatorD4 = 0;
int actuatorD5 = 0;
int actuatorD6 = 0;
int actuatorD7 = 0;
int actuatorD8 = 0;

unsigned long lastTimeSent = 0;

void setup() {
  // Initiate serial communication
  Serial.begin(38400);
  pinMode(pin_D2, OUTPUT);
  pinMode(pin_D3, OUTPUT);
  pinMode(pin_D4, OUTPUT);
  pinMode(pin_D5, OUTPUT);
  pinMode(pin_D6, OUTPUT);
  pinMode(pin_D7, OUTPUT);
  pinMode(pin_D8, OUTPUT);
  
  pinMode(sensor0, INPUT);
  pinMode(sensor1, INPUT);
  pinMode(sensor2, INPUT);
  pinMode(sensor3, INPUT);
}

void loop() {
  // read the serial input from the max patch
  // only one type of input expected
  while (Serial.available())
  {
    // parse the valid integers into the RGB led
    actuatorD2 = Serial.parseInt();
    actuatorD3 = Serial.parseInt();
    actuatorD4 = Serial.parseInt();
    actuatorD5 = Serial.parseInt();
    actuatorD6 = Serial.parseInt();
    actuatorD7 = Serial.parseInt();
    actuatorD8 = Serial.parseInt();

    // look for a newline
    if (Serial.read() == '\n')
    {
      // constrain to 255
      actuatorD2 = constrain(actuatorD2, 0, 1);
      actuatorD3 = constrain(actuatorD3, 0, 255);
      actuatorD4 = constrain(actuatorD4, 0, 1);
      actuatorD5 = constrain(actuatorD5, 0, 255);
      actuatorD6 = constrain(actuatorD6, 0, 255);
      actuatorD7 = constrain(actuatorD7, 0, 1);
      actuatorD8 = constrain(actuatorD8, 0, 1);
    }
  }

  // Write to the ledstrip
  digitalWrite(pin_D2, actuatorD2);
  analogWrite(pin_D3, actuatorD3);
  digitalWrite(pin_D4, actuatorD4);
  analogWrite(pin_D5, actuatorD5);
  analogWrite(pin_D6, actuatorD6);
  digitalWrite(pin_D7, actuatorD7);
  digitalWrite(pin_D8, actuatorD8);

  // Let's send max 25 times per second
  if (millis() > (lastTimeSent + 40))
  {
    // read the value from the sensors:
    sensorValue0 = analogRead(sensor0);
    sensorValue1 = analogRead(sensor1);
    sensorValue2 = analogRead(sensor2);
    sensorValue3 = analogRead(sensor3);

    // print to the maxpatch
    Serial.print(sensorValue0);
    Serial.print(" ");
    Serial.print(sensorValue1);
    Serial.print(" ");
    Serial.print(sensorValue2);
    Serial.print(" ");
    Serial.print(sensorValue3);
    Serial.print("\n");
    lastTimeSent = millis();
  }

}
